import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.PriorityQueue;
import java.util.Scanner;
import java.util.Set;
import java.util.TreeSet;


public class Hotels_JanE {
	static class V implements Comparable<V> {
		int x, d;
		V (int x, int d) {
			this.x = x;
			this.d = d;
		}
		public int compareTo(V other) {
			return new Integer(d).compareTo(other.d);
		}
		public String toString() { return "("+x+","+d+")"; }
	}
	public static void main(String[] args) {
		Scanner sc = new Scanner(System.in);
		int T = sc.nextInt();
		for (int tc=1;tc<=T;tc++){
			int F = sc.nextInt(), E = sc.nextInt();
			Map<Integer,List<Integer>> edges = new HashMap<Integer,List<Integer>>();
			TreeSet<Integer> all = new TreeSet<Integer>();
			for (int i=0; i<E; i++) {
				int R = sc.nextInt();
				int M = sc.nextInt();
				for (int at=R;at<F;at+=M){
					if(!edges.containsKey(at))edges.put(at, new ArrayList<Integer>());
					all.add(at);
					edges.get(at).add(M);
				}
			}
			if (!edges.containsKey(0))edges.put(0, new ArrayList<Integer>());
			PriorityQueue<V> qq = new PriorityQueue<V>();
			qq.add(new V(0, 0));
			Set<Integer> done = new HashSet<Integer>();
			List<V> finalset = new ArrayList<V>();
			while (!qq.isEmpty()) {
				V v = qq.poll();
				int x = v.x, d = v.d;
				if (done.contains(x))continue;
				done.add(x);
//				System.err.println(x+": "+d);
				finalset.add(v);
				for (int w : edges.get(x)) {
					if (x-w>=0)qq.add(new V(x-w, d));
					if (x+w<F)qq.add(new V(x+w, d));
				}
				Integer onder = all.lower(x);
				Integer boven = all.higher(x);
				if (onder != null) qq.add(new V(onder, d+x-onder));
				if (boven != null) qq.add(new V(boven, d+boven-x));
			}
//			System.out.println(all);
			Collections.sort(finalset, new Comparator<V>() {
				public int compare(V o1, V o2) {
					return new Integer(o1.x).compareTo(o2.x);
				}
			});
			finalset.add(new V(F-1, finalset.get(finalset.size()-1).d + F-1-finalset.get(finalset.size()-1).x));
//			System.out.println(finalset);
			int answer = -1, who = 0;
			for (int i=0; i<finalset.size()-1; i++) {
				V a = finalset.get(i), b=finalset.get(i+1);
				int x = (a.x + b.x + b.d - a.d) / 2;
//				System.out.printf("[%d(%d) %d(%d)]: %d\n",a.x,a.d, b.x,b.d, x);
				int d = a.d + x - a.x;
				if (d > answer) { answer = d; who = x; }
			}
			System.out.println(answer+" "+who);
		}
	}
}
