#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <cstring>
#include <cctype>
#include <climits>
#include <cassert>

#include <vector>
#include <deque>
#include <queue>
#include <stack>
#include <list>
#include <set>
#include <map>
#include <string>

#include <iostream>
#include <sstream>

#include <utility>
#include <functional>
#include <limits>
#include <numeric>
#include <algorithm> 

using namespace std;

int N, W, L;
int wag[123456];

bool mag(int T) {
	int nT = 1; // Number of trains
	int bT = 1;	// Begin of current part
	if (wag[0] > T) {
		nT = 2;
		bT = wag[0];
	}
	for (int i = 0; i < W; i++) {
		if (wag[i] >= bT + 2*T) {
			nT += 2;
			bT = wag[i];
		} else if (wag[i] >= bT + T) {
			nT++;
			bT += T;
		}
	}
	if (N >= bT + T)
		nT++;
	return (nT > L);
}

void doit() {
	cin >> N >> W >> L;
	for (int i = 0; i < W; i++)
		cin >> wag[i];
	sort(wag, wag+W);
	int lo;
	for (lo = 0; lo < N; lo++)
		if (!(mag(lo)))
			break;
	cout << lo << '\n';
}

int main () {
	int T;
	cin >> T;
	for (int t = 1; t <= T; t++) {
		doit();
	}
	return 0;
}
