#include<bits/stdc++.h>
using namespace std;
int n, W;
int ll[1005], rr[1005];
int pos(int i,int t){
	int l=ll[i], r=rr[i];
	int q = t / (r-l);
	if (q % 2 == 0) return l + t%(r-l);
	else return r - t%(r-l);
}
int solve_dijkstra(){
	// for each boat #x, T[x] is the first time that boat#x reaches ll[x] since we could reach boat #x.
	static int T[1005];
	fill(T,T+n,1e9);
	static bool done[1005];
	fill(done,done+n,false);
	for (int i=0; i<n; i++) if (ll[i]==0) T[i]=0;
	for (int iter=0; iter<n; iter++) {
		int x=-1;
		for (int i=0; i<n; i++) if (!done[i] && (x==-1 || T[i]<T[x])) x=i;
		if (T[x] == 1e9) break;
		done[x]=true;
		for (int y=0; y<n; y++) {
			int t = T[x];
			if (pos(y,t) <= pos(x,t)) continue;
			// find the first point in time at which boats x and y intersect in O(W) time.
			while (t < T[x]+2*(rr[x]-ll[x])*(rr[y]-ll[y])) { // both boats' periods divide 2*(rr[x]-ll[x])*(rr[y]-ll[y])
				if (pos(x,t+1) < pos(x,t)) t += pos(x,t)-ll[x]; else if (pos(y,t+1) > pos(y,t)) t += rr[y]-pos(y,t); else {
					// x moves forward, y moves backward.
					int dtmax=min(rr[x]-pos(x,t),pos(y,t)-ll[y]);
					int dt = pos(y,t)-pos(x,t);
					if (dt <= 2*dtmax){
						T[y] = min(T[y],t+pos(y,t)-ll[y]);
						break;
					} else t += dtmax;
				}
			}
		}
	}
	int ans = 1e9;
	for (int i=0; i<n; i++) if (rr[i] == W) ans = min(ans, T[i]+rr[i]-ll[i]);
	if (ans >= 1e9) return -1; else return ans;
}
int main() {
	int T; cin >> T;
	for (int tc=1; tc<=T; tc++) {
		cin >> n >> W;
		for (int i=0; i<n; i++) cin >> ll[i] >> rr[i];
		int ans = solve_dijkstra();
		if (ans == -1) puts("IMPOSSIBLE"); else printf("%d\n",ans);
	}
}
