#include<bits/stdc++.h>
using namespace std;
typedef long long LL;

// extended Euclidean algorithm function
LL xgcd(LL a,LL b,LL&x,LL&y) { // a * x + b * y = gcd(a, b) = g. returns g
	if (b == 0) { x = 1, y = 0; return a; }
	LL g (xgcd(b, a%b, x, y));
	swap(x, y), y -= (a/b)*x;
	return g;
}

LL ceil_div(LL x,LL y){
	if(x<0)return x/y; else return (x+y-1)/y;
}

int main() {
	int T; cin >> T;
	for (int tc=1; tc<=T; tc++) {
		LL R, S, Q; cin >> R >> S >> Q;
		LL A, B;
		LL g = xgcd(R, -S, A, B); B = -B;
		// A * R + B * S = g.
		A *= Q/g, B *= Q/g;
		// all solutions: (A+k*(-S/g), B+k*R/g)
		// A+k*(-S/g) >= 1 --> k >= (1-A)/(-S/g)
		// B+k*R/g >= 1 --> k >= (1-B)/(R/g)
		LL k = max(ceil_div(1-A,-S/g),ceil_div(1-B,R/g));
		cout << A+k*(-S/g) << " " << B+k*(R/g) << endl;
	}
}
