// Almost identical to Raymond's other solution, except with the order of the
// loops changed in the Floyd-Warshall algorithm. This will give wrong answers.

#include <iostream>
#include <algorithm>

using namespace std;

int F, E, R[123], M[123], d[123][123], c;
pair<int,int> s[123456];

void doit() {
// Read and setup
	c = 1;
	cin >> F >> E;
	s[0] = make_pair(0,E);
	for (int i = 0; i < E; i++) {
		cin >> R[i] >> M[i];
		for (int j = R[i]; j < F; j += M[i]) {
			s[c] = make_pair(j,i);
			c++;
		}
	}
	s[c] = make_pair(F-1,E+1);
	c++;
	E+=2;
	for (int i = 0; i < E; i++) {
		for (int j = 0; j < E; j++)
				d[i][j] = 1001001001;
		d[i][i] = 0;
	}
	sort(s, s+c);

// Set distances between elevators
	for (int i = 0; i < c-1; i++) {
		int e1 = s[i].second;
		int e2 = s[i+1].second;
		d[e1][e2] = min(d[e1][e2], s[i+1].first - s[i].first);
		d[e2][e1] = d[e1][e2];
	}
	for (int i = 0; i < E; i++)
	for (int j = 0; j < E; j++)
	for (int k = 0; k < E; k++)
		d[i][j] = min(d[i][j], d[i][k] + d[k][j]); // <-- changed the order of the variables

// Find answer
	int max = -1;
	int argmax = -1;
	for (int i = 0; i < c-1; i++) {
		int bottom = s[i].first;
		int dbottom = d[E-2][s[i].second];
		int top = s[i+1].first;
		int dtop = d[E-2][s[i+1].second];
		int mid = (bottom + top + dtop - dbottom) / 2;
		if (dbottom + (mid - bottom) > max) {
			max = dbottom + mid - bottom;
			argmax = mid;
		}
	}
	cout << max << " " << argmax << "\n";
}

int main () {
	int T;
	cin >> T;
	for (int t = 1; t <= T; t++) {
		doit();
	}
	return 0;
}
